% Copyright (C) 2008-2010 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Optimality conditions}
\label{introoptim-section-optimalityconditions}

In this section, we present several types of optimization problems,
and analyze in each case the conditions which allow to state that 
a given point is an \emph{optimum} of the problem.
The theorems in the next sections allow to state first order and 
second order necessary conditions.
Our presentation focus on the unconstrained univariate problems 
and unconstrained multivariate problem.

\index{stationary point}
The figure \ref{fig-introoptim-stationnarypoint} presents the difference between 
a stationary point, associated with a zero gradient, and an optimum, 
associated with a zero gradient and a positive curvature.
Obviously, the stationary point is not a local optimum, and only
the optimum is lower than all the points in its neighborhood.

\begin{figure}
\begin{center}
\includegraphics[width=7cm]{optimcond//stationnarypoint.pdf}
\end{center}
\caption{Difference between a stationnary point and an optimum.}
\label{fig-introoptim-stationnarypoint}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Unconstrained univariate problem}

In this section, we derive the first and second order necessary conditions 
for the unconstrained univariate problem
\begin{eqnarray}
\label{introptim-unconsunivarpb}
\min_{x\in\RR} f(x).
\end{eqnarray}
We assume that the function $f$ is twice continuously differentiable on $\RR$.

\begin{proposition}
\emph{(Necessary conditions for unconstrained univariate minimum)}
\label{introoptim-necessaryunivar}
Assume that the point $x^\star$ is a local minimum of the problem \ref{introptim-unconsunivarpb}.
Then the following two conditions are satisfied
\begin{itemize}
\item $f'(x^\star) = 0$,
\item $f''(x^\star)\geq 0$.
\end{itemize}
\end{proposition}

\index{first order condition}
The condition $f'(x^\star) = 0$ is called the \emph{first order condition}
and states that $x^\star$ is a stationary point of $f$.
\index{second order condition}
The condition $f''(x^\star)\geq 0$ is called the \emph{second order condition}
and states that the local curvature is positive.
The previous theorem does not make any difference between strong and week local
minimum.

\begin{proof}
Let us consider the following Taylor expansion of $f$ in a $\delta-$neighborhood of the minimum.
There exists a $\delta>0$ such that
\begin{eqnarray}
f(x^\star+\epsilon) = f(x^\star) + \epsilon f'(x^\star) + \frac{1}{2}\epsilon^2 f''(x^\star)+O(\epsilon^3),
\end{eqnarray}
for any sufficiently small $\epsilon$, i.e. for $|\epsilon|<\delta$.
By hypothesis, the point $x^\star$ is a local minimum of the problem \ref{introptim-unconsunivarpb},
so that $f(x^\star+\epsilon) \geq f(x^\star)$. 

We are going to show that $f'(x^\star)= 0$ by contradiction.
Let us assume that $f'(x^\star)\neq 0$, that is, the local slope of the function $f$ is different 
from zero. First consider the case where $f'(x^\star)<0$, i.e. the slope is negative.
Then there must exist a small positive $\overline{\epsilon}>0$ such that 
$\epsilon f'(x^\star) + \frac{1}{2}\epsilon^2 f''(x^\star)+O(\epsilon^2)<0$ for any small positive 
$\epsilon$, i.e. for $0<\epsilon<\overline{\epsilon}<\delta$.
This implies that $f(x+\epsilon)<f(x^\star)$, which contradicts the optimality hypothesis.
Second, consider the case where $f'(x^\star)>0$, i.e. the slope is positive.
Then there must exist a small $\overline{\epsilon}<0$ such that 
$\epsilon f'(x^\star) + \frac{1}{2}\epsilon^2 f''(x^\star)+O(\epsilon^2)<0$ for 
any small negative $\epsilon$ i.e. for $-\delta <\overline{\epsilon}<\epsilon<0$.
This implies again that $f(x+\epsilon)<f(x^\star)$, which contradicts the optimality hypothesis.
Therefore $f'(x^\star)=0$.

The local Taylor expansion is therefore simplified into 
\begin{eqnarray}
\label{introopim-univartaylorsimplified}
f(x^\star+\epsilon) = f(x^\star) + \frac{1}{2}\epsilon^2 f''(x^\star)+O(\epsilon^3),
\end{eqnarray}
We are going to show that $f''(x^\star)\geq 0$ by contradiction.
Suppose that $f''(x^\star)<0$. 
Then, by continuity, $f''$ will remain negative in some neighborhood of $x^\star$. 
If $|\epsilon|$ is small enough so that $x^\star+\epsilon$
is in that neighborhood, the equation \ref{introopim-univartaylorsimplified} 
implies that $f(x^\star+\epsilon)<f(x^\star)$. 
This contradicts the optimality hypothesis. 
Therefore we have $f''(x^\star)\geq 0$.
\end{proof}

It must be noticed that the Taylor expansion is central in the proof and is made 
possible because the cost function is assumed to be smooth.
If the cost function is non smooth, a different approach would be required.

The other particularity in this proof is that a different value of $\epsilon$ is chosen
depending on the sign of the first derivative $f'(x^\star)$ :
\begin{itemize}
\item a positive $\epsilon$ step is used when $f'(x^\star)<0$,
\item a negative $\epsilon$ step is used when  $f'(x^\star)>0$,
\end{itemize}
i.e. the $\epsilon$ step is taken toward decreasing values of $f$.
It would have been shorter to consider $\epsilon=-f'(x)$. 
By decomposing the problem in two different cases, we emphasize 
that this corresponds more simply to "taking the direction where 
$f$ decreases". This situation is presented in figure \ref{fig-twocasesfirstorder}.
This feature of the proof will be used later in the multivariate case.

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{optimcond/univar-casefnegative.pdf}
\includegraphics[width=5cm]{optimcond/univar-casefpositive.pdf}
\end{center}
\caption{Two cases used in the proof for first order conditions. - 
On the left, the case $f'(x^\star)<0$, where we consider the 
"direction" $\epsilon>0$. On the right, the case $f'(x^\star)>0$, where we consider the 
"direction" $\epsilon<0$. }
\label{fig-twocasesfirstorder}
\end{figure}

\begin{proposition}
\emph{(Sufficient conditions for unconstrained univariate minimum)}
\label{introoptim-sufficientunivar}
If the following two conditions are satisfied
\begin{itemize}
\item $f'(x^\star) = 0$,
\item $f''(x^\star)> 0$,
\end{itemize}
then the point $x^\star$ is a strong local minimum of the 
problem \ref{introptim-unconsunivarpb}.
\end{proposition}

\begin{proof}
Since the first order condition $f'(x^\star)=0$ is satisfied, 
the Taylor expansion of $f$ in a $\delta-$neighborhood of the minimum simplifies into 
\begin{eqnarray}
f(x^\star+\epsilon) = f(x^\star) + \frac{1}{2}\epsilon^2 f''(x^\star)+O(\epsilon^3),
\end{eqnarray}
for $|\epsilon|<\delta$. 
The second order condition $f''(x^\star)> 0$ implies that $f(x^\star+\epsilon) > f(x^\star)$,
which concludes the proof.
\end{proof}

Notice that the necessary conditions are associated to a weak local optimum,
while sufficient conditions are associated with a strong local optimum.
If the curvature condition is modified to $f''(x^\star)\geq 0$, then only
a weak local minimum is guaranteed.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Examples of univariate optimization problems}

In this section, we consider several examples of univariate optimization
problems. We focus on the different combinations of satisfaction of 
the first and second order conditions.

\begin{example}
\emph{(Example of a univariate point which satisfies the first order condition 
but not the second order condition.)}
Consider the univariate optimization problem \ref{introptim-unconsunivarpb}
where the function is $f(x) = -x^2$. Suppose that we are interested 
in the point $x^\star=0$. We first check that the first order condition is  
satisfied. The first derivative is $f'(x) = -2x$, so that $f'(x^\star)=0$.
The situation is presented in figure \ref{fig-introoptim-falseminimum1}.
Obviously, this is not a local minimum. This can be confirmed by computing 
the second derivative $f''(x)=-2<0$. Therefore, the point $x^\star=0$ is a local 
maximum, not a local minimum.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{optimcond/falselocaloptimum-univar1.pdf}
\end{center}
\caption{A "false" local minimum : a true local maximum.}
\label{fig-introoptim-falseminimum1}
\end{figure}

\begin{example}
\emph{(Example of a univariate point which satisfies the first order condition 
but not the second order condition.)}
Consider the univariate optimization problem \ref{introptim-unconsunivarpb}
where the function is $f(x) = x^3$. Suppose that we are interested 
in the point $x^\star=0$. We first check that the first order condition is  
satisfied. The first derivative is $f'(x) = 3x^2$, so that $f'(x^\star)=0$.
The situation is presented in figure \ref{fig-introoptim-falseminimum2}.
Obviously, this is not a local minimum. This can be confirmed by computing 
\index{inflection}
the second derivative $f''(x)=-6x=0$. Therefore, the point $x^\star=0$ is an \emph{inflection} 
point, not a local minimum.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{optimcond/falselocaloptimum-univar2.pdf}
\end{center}
\caption{A "false" local minimum : a true inflection point.}
\label{fig-introoptim-falseminimum2}
\end{figure}

\begin{example}
\emph{(Example of a univariate point which satisfies both first and second order conditions.)}
Consider the univariate optimization problem \ref{introptim-unconsunivarpb}
where the function is $f(x) = x^2$. Suppose that we are interested 
in the point $x^\star=0$. We first check that the first order condition is  
satisfied. The first derivative is $f'(x) = 2x$, so that $f'(x^\star)=0$.
We additionally compute the second derivative $f''(x)=2>0$, which shows that 
second order conditions are satisfied. 
Therefore, the point $x^\star=0$ is a strong local minimum.
\end{example}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Unconstrained multivariate problem}

In this section, we derive the first and second order necessary conditions 
for the unconstrained multivariate problem
\begin{eqnarray}
\label{introptim-unconsmultivarpb}
\min_{\bx\in\RR^n} f(\bx).
\end{eqnarray}
We assume that the function $f$ is twice continously differentiable on $\RR^n$.

\begin{proposition}
\emph{(Necessary conditions for unconstrained multivariate minimum)}
\label{introoptim-necessarymulti}
Assume that the point $\bx^\star$ is a local minimum of the problem \ref{introptim-unconsmultivarpb}.
Then the following two conditions are satisfied
\begin{itemize}
\item $g(\bx^\star) = 0$,
\item $H(\bx^\star)$ is positive semi-definite.
\end{itemize}
\end{proposition}

\begin{proof}
Let us consider the following Taylor 
expansion of $f$ in a $\delta-$neighborhood of the minimum.
There exists a $\delta > 0$ such that 
\begin{eqnarray}
f(\bx^\star+\epsilon \bp) = f(\bx^\star) + \epsilon \bp^T \bg(\bx^\star) 
+ \frac{1}{2}\epsilon^2 \bp^T H(\bx^\star)\bp+O(\epsilon^3),
\end{eqnarray}
for any sufficiently small positive $\epsilon$, i.e. for $0<\epsilon<\delta$ and 
any direction $\bp\in\RR^n$. 
By hypothesis, the point $\bx^\star$ is a local minimum of the problem \ref{introptim-unconsmultivarpb}
so that $f(\bx^\star+\epsilon \bp) \geq f(x^\star)$.

We are going to prove that $\bg(\bx^\star) =0$ by contradiction.
Suppose that $\bg(\bx^\star)$ is non-zero. If we choose $\bp = -\bg(\bx^\star)$,
we have 
\begin{eqnarray}
\bp^T \bg(\bx^\star) = - \|\bg(\bx^\star)\|^2 <0. 
\end{eqnarray}
Such a vector $\bp$ is called a \emph{descent direction}
at $\bx^\star$. 
Then there must exist a small positive $\overline{\epsilon}>0$ such that 
$\epsilon \bp^T \bg(\bx^\star) 
+ \frac{1}{2}\epsilon^2 \bp^T H(\bx^\star)\bp+O(\epsilon^3)<0$ for any small 
positive $\epsilon$, that is, for $0<\epsilon<\overline{\epsilon}<\delta$.
Therefore $f(\bx^\star+\epsilon \bp) < f(\bx^\star)$, which contradicts the 
optimality condition. This proves that $\|\bg(\bx^\star) \|=0$.

The local Taylor expansion is therefore simplified into 
\begin{eqnarray}
\label{introopim-multivartaylorsimplified}
f(\bx^\star+\epsilon \bp) = f(\bx^\star) 
+ \frac{1}{2}\epsilon^2 \bp^T H(\bx^\star)\bp+O(\epsilon^3).
\end{eqnarray}
We are going to show that $H(\bx^\star)$ is positive semi-definite by contradiction.
Suppose that $H(\bx^\star)$ is indefinite. Then, by continuity, the matrix $H$ will remain indefinite 
in some neighborhood of $\bx^\star$. If $\epsilon$ is small enough so that $\bx^\star+\epsilon \bp$
is in that neighborhood, the equality \ref{introopim-multivartaylorsimplified} can be used and 
there exists a vector $\bp$ such that 
$\bp^T H(\bx^\star)\bp <0$. The simplified Taylor expansion \ref{introopim-multivartaylorsimplified} 
shows that $f(\bx^\star+\epsilon \bp)<f(\bx^\star)$. This contradicts the optimality hypothesis. Therefore 
the matrix $H(\bx^\star)$ is positive semi-definite.
\end{proof}

\begin{proposition}
\emph{(Sufficient conditions for unconstrained multivariate minimum)}
\label{introoptim-sufficientmulti}
If the following two conditions are satisfied
\begin{itemize}
\item $\bg(\bx^\star) = 0$,
\item $H(\bx^\star)$ is positive definite,
\end{itemize}
then the point $\bx^\star$ is a strong local minimum of the 
problem \ref{introptim-unconsmultivarpb}.
\end{proposition}

\begin{proof}
Since the first order condition $\bg(\bx^\star)=0$ is satisfied, 
the Taylor expansion of $f$ in a $\delta-$neighborhood of the minimum simplifies into 
\begin{eqnarray}
f(\bx^\star+\epsilon \bp) = f(\bx^\star) + \frac{1}{2}\epsilon^2 \bp^T H(\bx^\star)\bp+O(\epsilon^2),
\end{eqnarray}
for any sufficiently small positive $\epsilon$, that is, for $0<\epsilon<\delta$ and $\bp\in\RR^n$. 
By the second order hypothesis, the matrix $H(\bx^\star)$ is positive definite, 
which implies that $\bp^T H(\bx^\star)\bp>0$ for any direction $\bp$. 
This proves that $f(\bx^\star+\epsilon\bp) > f(\bx^\star)$ and concludes the proof.
\end{proof}

In this section, we will not give examples for the order one and order 
two conditions. Instead, we will consider the special case where 
the function is quadratic and will give examples of the 
various situations which can occur.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Quadratic functions}

In the neighborhood of any point, a smooth function $f$ can be approximated
by a quadratic function: this is a consequence of the Taylor expansion of $f$ in
the neighborhood of any point $\bx$. Thus, it is of great practical value to consider quadratic 
functions as examples of what happens when we are considering 
a neighborhood of any point of a smooth function. 

Moreover, the analysis is greatly simplified by the special nature of 
quadratic functions. Indeed, many theorems associated with the convergence 
properties or convergence rate of optimization algorithms are based on 
the special case when the function is quadratic. 

Let us consider the following quadratic function 
\begin{eqnarray}
\label{introoptim-quadraticmodel}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bx\in\RR^n$, the vector $\bb\in\RR^n$ is a given vector and 
$H$ is a $n\times n$ matrix. 

We could add a constant term in the function and consider the quadratic function 
\begin{eqnarray}
\bc +  \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bc\in\RR^n$ is a given vector. But there is no loss of 
generality when we consider that $\bc=0$, because the proposition \ref{introoptim-necessarymulti}
implies that the optimum $\bx^\star$ is the solution of $g(\bx^\star) = 0$. 
Since the constant term $\bc$ does not appear in the gradient of the function,
we can as well remove it from the quadratic function we are studying, without 
any modification of the optimum $\bx^\star$.

We can, without loss of generality, assume that $H$ is symmetric. 
Indeed, 
\begin{eqnarray}
\bx^T H \bx 
&=& \frac{1}{2} \bx^T H \bx + \frac{1}{2} \bx^T H \bx.
\end{eqnarray}
The symmetry of the dot product between the vectors $\bx$
and $H \bx$ implies that $\bx^T (H \bx) = (H \bx)^T \bx$.
This implies 
\begin{eqnarray}
\bx^T H \bx 
&=& \frac{1}{2} \bx^T (H \bx) + \frac{1}{2} (H \bx)^T \bx \\
&=& \frac{1}{2} \bx^T H \bx + \frac{1}{2} \bx^T H^T \bx \\
&=& \frac{1}{2} \bx^T \left(H+H^T\right)\bx.
\label{introoptim-quadraticmodel1}
\end{eqnarray}
The matrix $\frac{1}{2} \left(H+H^T\right)$ is symetric. Therefore, the 
equation \ref{introoptim-quadraticmodel1} implies 
that there is no point in making a difference between the matrices $H$ and 
$\frac{1}{2} \left(H+H^T\right)$. 
Therefore, we can assume that the matrix $H$ is symetric.

The gradient of $f$ is 
\begin{eqnarray}
\bg(\bx) = \bb + H \bx,
\label{introoptim-quadraticmodel2}
\end{eqnarray}
and the Hessian matrix of $f$ is the matrix $H$.

For any vector $\bp\in\RR^n$ and any scalar $\alpha\in\RR$, we have 
the equality 
\begin{eqnarray}
\label{introoptim-quadratictaylor}
f(\bx+\alpha\bp) = f(\bx) + \alpha\bp^T(H\bx+\bb) + \frac{1}{2} \alpha^2 \bp^T H \bp.
\end{eqnarray}
The proof of this equality is given in the exercise \ref{introoptim-exer-taylorquad}.
The equality \ref{introoptim-quadratictaylor} can be understood 
as an \emph{exact} Taylor expansion of $f$,
which is valid at any point $\bx\in\RR^n$ and whatever the value $\alpha\in\RR$.
Hence, it is a \emph{global} property, instead of being valid only in a neighborhood of $\bx$.
Assume that $\bx^\star$ is a stationary point of $f$. Then, 
the equation \ref{introoptim-quadraticmodel2} implies that the point $\bx^\star$ satisfies the 
equality
\begin{eqnarray}
\label{introoptim-quadraticstationnary}
H\bx^\star=-\bb.
\end{eqnarray}
If the system of linear equations \ref{introoptim-quadraticstationnary} has no solution, 
then $f$ has no stationary point. This may happen if the Hessian 
matrix is zero. In this case, the function $f$ is simply linear. 
Therefore $f$ is unbounded (neither below, nor above). 

Assume that $\bx^\star$ is a stationary point and satisfies the equation \ref{introoptim-quadraticstationnary}. 
Let us introduce the function $\phi_{\bp}:\RR \rightarrow \RR$ defined by 
\begin{eqnarray}
\label{introoptim-quadratictaylor1-bis}
\phi_{\bp}(\alpha)=f(\bx^\star+\alpha\bp),
\end{eqnarray}
for any $\alpha \in\RR$ and any vector $\bp\in\RR^n$.
Then, we can simplify the equation \ref{introoptim-quadratictaylor} and 
get
\begin{eqnarray}
\label{introoptim-quadratictaylor2}
\phi_{\bp}(\alpha)=f(\bx^\star) + \frac{1}{2} \alpha^2 \bp^T H \bp,
\end{eqnarray}
for any $\alpha\in\RR$. 

Let $\{\lambda_i\}_{i=1,n}\in\RR$ be the eigenvalues of the Hessian 
matrix $H$ and let $\{\bu_i\}_{i=1,n}\in\RR^n$ be the associated eigenvectors.
By hypothesis, the matrix $H$ is symmetric definite positive. 
This implies that the eigenvalues are real and that 
there is an orthonormal basis of eigenvectors 
(see Golub and Van Loan's \cite{citeulike:2122238}, 
section 8.1, "Symetric Schur Decomposition").
Therefore, $\bu_i^T \bu_j = 0$ for $i\neq j$ and $\bu_i^T \bu_i = 1$.

Consider now the equality \ref{introoptim-quadratictaylor2} when 
the direction $\bp$ is chosen to be an eigenvector $\bu_i$ for some $i=1,n$.
We get, 
\begin{eqnarray}
\label{introoptim-quadratictaylor3}
\phi_i(\alpha) = f(\bx^\star) + \frac{1}{2} \lambda_i \alpha^2,
\end{eqnarray}
for all $i=1,2,\ldots,n$ and for any $\alpha\in\RR$. 
This result leads to the two following remarks.
\begin{itemize}
\item The behavior of $f$ in the direction of an eigenvector $\bu_i$,
is quadratic in $\alpha$.
\item The curvature of $f$ in the direction of an eigenvector $\bu_i$
depends on the sign of the eigenvalue $\lambda_i$.
\end{itemize}
If $\lambda_i$ is positive (resp. negative), then the function is 
increasing (resp. decreasing) along the direction $\bu_i$.
If $\lambda_i$ is zero, then the function is constant along the 
direction $\alpha \bu_i$.

Depending on the signs of the eigenvalues of the matrix $H$, three cases are possible.
\begin{itemize}
\item When the eigenvalues are all positive, the point $\bx^\star$ is the 
unique global minimizer of $f$. The contours of $f$ are 
ellipsoids, as presented in figure \ref{fig-introoptim-defpos}.
\item When the eigenvalues are positive but at least one eigenvalue 
is zero, the point $\bx^\star$ is a weak local optimum. 
This situation is presented in figure \ref{fig-introoptim-nodefzero}.
\item When the eigenvalues are of opposite signs, the point $\bx^\star$ is 
a saddle point and the function $f$ is unbounded neither above, nor below.
This situation is presented in figure \ref{fig-introoptim-saddle3dcut}.
\end{itemize}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/introoptim-contourdefpos.pdf}
\end{center}
\caption{Contour of a quadratic function -- The eigenvalues of the matrix are both positive.}
\label{fig-introoptim-defpos}
\end{figure}


\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/introoptim-contournotdef.pdf}
\end{center}
\caption{Contour of a quadratic function -- One eigenvalue is zero, the other is positive.}
\label{fig-introoptim-nodefzero}
\end{figure}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/introoptim-saddlecontourcut.pdf}
\end{center}
\caption{A saddle point -- contour plot with cuts along the eigenvectors. 
The Hessian matrix 
has one negative eigenvalue and one positive eigenvalue.
The function is quadratic along the eigenvectors directions.}
\label{fig-introoptim-saddle3dcut}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Convex functions}
\label{introoptim-section-opticonvexfuns}

If the function $f$ is convex on a convex set $C\subset\RR^n$, then
our task of finding a global minimizer is easier because of the 
following theorem.

\begin{proposition}
\emph{(Unconstrained convex optimization - part 1)}
\label{introoptim-prop-opticonvexfuns1}
Assume that $f$ is a convex function on the convex set $C$.
If $\bx^\star\in C$ is a local minimizer, therefore it is 
a global minimizer.
\end{proposition}

\begin{proof}
Assume that $\bx^\star$ is a local minimizer. 
Let us prove that $\bx^\star$ is a global minimizer.
Let us assume that $\bx^\star$ is 
not a global minimizer and let us prove that this leads to a 
contradiction.
Assume that $\by\in C$ is so that $f(\by)< f(\bx^\star)$.
Consider now the point $\bx=\theta \by + (1-\theta)\bx^\star$ 
for any $\theta$ such that $0< \theta \leq 1$. 
We 
Since $f$ is convex, we have the inequality 
\begin{eqnarray}
\label{introoptim-section-opticonvexfuns1}
f(\bx) \leq \theta f(\by) + (1-\theta) f(\bx^\star).
\end{eqnarray}
Moreover, the inequality $f(\by)< f(\bx^\star)$ implies 
$\theta f(\by)< \theta f(\bx^\star)$ for any $\theta$ such that 
$0< \theta \leq 1$. Therefore, 
\begin{eqnarray}
\theta f(\by) + (1-\theta) f(\bx^\star) < \theta f(\bx^\star) + (1-\theta) f(\bx^\star) = f(\bx^\star).
\end{eqnarray}
We plug the previous inequality into the equation \ref{introoptim-section-opticonvexfuns1}
and get 
\begin{eqnarray}
f(\bx) < f(\bx^\star).
\end{eqnarray}
Therefore, any neighborhood of $\bx^\star$ contains a point $\bx$ where the previous 
inequality is satisfied. Hence the point $\bx^\star$ is not a local 
minimizer of $f$, which contradict our assumptions. Therefore, the point $\bx^\star$
is a global minimizer, which concludes the proof.
\end{proof}

Notice that the previous theorem does not make any assumption on
the differentiability of $f$: even non-smooth convex functions may be used in this 
theorem.

For differentiable functions, the following theorem allows to 
state first-order conditions for a minimizer of a convex function.

\begin{proposition}
\emph{(Unconstrained convex optimization - part 2)}
\label{introoptim-prop-opticonvexfuns2}
Assume that $f$ is a convex function on the convex set $C$.
Assume that $f$ is continously differentiable on $C$. If $\bx^\star \in C$ is 
a stationary point, therefore $\bx^\star$ is a global minimizer.
\end{proposition}

\begin{proof}
Since the function $f$ is convex and continuously differentiable, we have
\begin{eqnarray}
f(\bx)\geq f(\bx^\star) + \bg(\bx^\star)^T (\bx - \bx^\star )
\end{eqnarray}
for all $\bx \in C$. But $\bx^\star$ is a stationary point so that $\bg(\bx^\star)=0$.
The inequality then reduces to:
\begin{eqnarray}
f(\bx)\geq f(\bx^\star) 
\end{eqnarray}
for all $\bx \in C$, which proves that $\bx^\star$ is a global minimizer. 
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Optimum of Rosenbrock's function}
\label{introoptim-optimality-rosenbrock}
\index{Rosenbrock H.H.}

In this section, we consider Rosenbrock's function and prove that the 
point $\bx^\star=(1,1)^T$ is a local optimum of the unconstrained 
optimization problem.

Let us consider Rosenbrock's function \cite{citeulike:1903787}
\begin{eqnarray}
\label{introoptim-rosenbrock}
f(\bx) = 100(x_2 - x_1^2)^2 + (1-x_1)^2.
\end{eqnarray}
The following \scifun{rosenbrock} function computes the 
function value \scivar{f}, the gradient \scivar{g} and the Hessian matrix \scivar{H} 
of Rosenbrock's function.
\lstset{language=scilabscript}
\begin{lstlisting}
function [f, g, H] = rosenbrock ( x )
  A = x(2) - x(1)^2
  B = 1-x(1)
  fm(1) = 10*A
  fm(2) = B
  f = sum(fm.^2)
  g(1) = - 400*A*x(1) - 2*B
  g(2) = 200 * A
  H(1,1) = 1200*x(1)^2 - 400*x(2) + 2
  H(1,2) = -400*x(1)
  H(2,1) = H(1,2)
  H(2,2) = 200
endfunction
\end{lstlisting}


The proposition \ref{introoptim-sufficientmulti} suggests 
to look at the gradient and the Hessian matrix at the point $\bx^\star$,
as in the following script.
\lstset{language=scilabscript}
\begin{lstlisting}
xopt = [1.0 1.0]';
[ f , g , H ] = rosenbrock ( xopt );
mprintf ( "Computed f(x) = %f (expected = %f)\n", f, 0.0 );
mprintf ( "Computed g(x) = \n");disp(g');
mprintf ( "Computed H(x) = \n");disp(H);
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
Computed f(x) = 0.000000 (expected = 0.000000)
Computed g(x) = 
    0.    0.  
Computed H(x) = 
    802.  - 400.  
  - 400.    200.  
\end{lstlisting}


Indeed, the first order condition is verified since the gradient
is zero. The following statements allows to check our 
results with the numerical derivatives computed by the \scifun{derivative}
function.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[gfd , Hfd ] = derivative(rosenbrock , xopt , H_form='blockmat')
 Hfd  =
    802.00001  - 400.  
  - 400.         200.  
 gfd  =
   1.0D-10 *
    146.67356  - 0.0001110  
\end{lstlisting}

The result computed with our analytical formula and the 
numerical derivative match, so that we are confident that 
our computation is correct.

We are now interested in the second order conditions, so that we 
compute the eigenvalues of the Hessian matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
-->spec(H)
 ans  =
    0.3993631  
    1001.6006  
\end{lstlisting}
Since the two eigenvalues of the approximated Hessian matrix are 
both positive, the order two conditions are satisfied.
The point $\bx^\star=(1,1)^T$ is therefore a strong local 
optimum.

We emphasize that the previous computations only ensures that the 
point $\bx^\star=(1,1)^T$ is a \emph{local} optimum, as proved by 
the proposition \ref{introoptim-sufficientmulti}. In fact, the 
point $\bx^\star=(1,1)^T$ is the \emph{global} optimum. 
The only tool we have presented to conclude this would be to prove that the function is convex.
In this case, the proposition \ref{introoptim-prop-opticonvexfuns1} would 
allow to conclude. 
For example, we may compute the eigenvalues of the Hessian 
matrix and to prove that these eigenvalues are strictly positive, for 
any point $\bx\in\RR^n$. 
In general, this is a difficult work.

The following script allows to plot the contours of Rosenbrock's function in the neighborhood 
of $\bx^\star$. We define the function \scifun{rosenbrockC} which takes two inputs arguments and returns 
the value of the function. This header is required by the \scifun{contour} function 
in order to produce the plot. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = rosenbrockC ( x1 , x2 )
  f = rosenbrock ( [x1,x2]' )
endfunction
x = linspace ( 0.9 , 1.1 , 100 );
y = linspace ( 0.9 , 1.1 , 100 );
contour ( x , y , rosenbrockC , [0.1 1 2 4] )
\end{lstlisting}
The plot is presented in figure \ref{fig-answer-rosenbrockcontoursneigh}.
The ellipsoids are extremely elongated, so that the contours seem
to be parallel lines. We will review this topic when we will consider 
the condition number of the Hessian matrix.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/answerexer-contourrosenbrock.pdf}
\end{center}
\caption{Contour of Rosenbrock's function in the neighborhood of the minimum $\bx^\star=(1,1)^T$.}
\label{fig-answer-rosenbrockcontoursneigh}
\end{figure}

We can add to the contour plot the eigenvectors of the Hessian matrix.
In the following session, we compute the eigenvectors \scivar{R} and the eigenvalues matrix 
\scivar{D}. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->[R,D] = spec(H)
 D  =
    0.3993608    0.         
    0.           1001.6006  
 R  =
  - 0.4464988  - 0.8947842  
  - 0.8947842    0.4464988  
\end{lstlisting}
The eigenvectors are stored column by column, i.e. the eigenvector associated 
with the first eigenvalue is \scivar{R(:,1)}
and the eigenvector associated with the second eigenvalue is \scivar{R(:,2)}.
In the following script, we plot the optimum on the contour plot.
Then we plot the eigenvectors, by scaling the normalized vectors 
(if not, the points would be outside the plot).
\lstset{language=scilabscript}
\begin{lstlisting}
plot ( xopt(1),xopt(2) , "g+" )
sc = 1.e-1
plot ( xopt(1) + sc * R(1,1) , xopt(2) + sc * R(2,1) , "r*" )
plot ( xopt(2) + sc * R(1,2) , xopt(2) + sc * R(2,2) , "bo" )
\end{lstlisting}
This produces the plot presented in figure \ref{fig-answer-rosenbrockeigenvec}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/rosenbrock-eigenvectors.pdf}
\end{center}
\caption{Eigenvectors of the Hessian matrix of Rosenbrock's function in the neighborhood of the minimum $\bx^\star=(1,1)^T$.}
\label{fig-answer-rosenbrockeigenvec}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Limitation of floating point accuracy}
\index{floating point}
\label{introoptim-section-floatlimit}

In this section, we present a fundamental limitation caused 
by rounding errors generated by the floating point arithmetic.
This limitation leads to an estimate of the best possible 
accuracy which can be achieved by a floating point 
algorithm searching for the minimum of a function and using function 
values only. We emphasize that, if the function is differentiable, the 
gradient should be used, which leads to an improved accuracy.

The discussion is split into two parts, where the 
first part focuses on univariate optimization and the second part 
extends the result to multivariate optimization.

When Scilab evaluates the function value at the 
point $x^\star$, it commits a rounding error which is the the 
result of the limited accuracy of floating point numbers. Hence the 
exact function value $f(x^\star)$ is represented by the floating point 
number $fl(f(x^\star))$. 
The difference between the floating point value $fl(f(x^\star))$ and the 
exact value $f(x^\star)$ depends on the algorithm to evaluate the function and the
machine epsilon $\epsilon_M$, which represents the relative error 
associated with normalized floating point numbers. 
The real numbers used by Scilab are \emph{doubles}, which are associated with the relative 
precision $\epsilon_M\approx 10^{-16}$. 
This leads to the following result.

\begin{proposition}
\emph{(Limitation of floating point accuracy - Univariate case)}
\label{introoptim-prop-floatlim1}
Assume that $f:\RR\rightarrow\RR$ is a quadratic 
univariate function and that $x^\star \in\RR$ is a strong local 
minimum of the function $f$.
Assume that the floating point system is associated with the 
machine epsilon $\epsilon_M>0$ and that the floating point function value 
at the point $x^\star$ satisfies 
\begin{eqnarray}
\label{introoptim-eq-floatlimit1}
fl(f(x^\star)) = f(x^\star) ( 1+\delta ),
\end{eqnarray}
where $|\delta| \leq \epsilon_M$. If the point $\overline{x} \in\RR$ satisfies 
\begin{eqnarray}
\label{introoptim-eq-floatlimit8}
|\overline{x} - x^\star| \leq  \sqrt{\frac{2 \epsilon_M |f(x^\star)|}{f''(x^\star)}},
\end{eqnarray}
therefore, 
\begin{eqnarray}
\label{introoptim-eq-floatlimit1d}
fl(f(\overline{x})) = fl(f(x^\star)).
\end{eqnarray}
For such a point, the first derivative $f'(\overline{x})$ satisfies
\begin{eqnarray}
\label{introoptim-eq-floatlimitfp1}
|f'(\overline{x})| \leq  \sqrt{2 \epsilon_M |f(x^\star)|f''(x^\star)}.
\end{eqnarray}
\end{proposition}

The equation \ref{introoptim-eq-floatlimit1b} simply states that the floating 
point representations of $f(\overline{x})$ and $f(x^\star)$ are equal. Indeed, 
assume that we have
\begin{eqnarray}
\label{introoptim-eq-floatlimit1b}
|f(\overline{x}) - f(x^\star)| \leq \epsilon_M |f(x^\star)|.
\end{eqnarray}
In that case, there is no way to distinguish the points $\overline{x}$ and 
$x^\star$ with respect to the floating point representations of their function values. 
Hence the equality \ref{introoptim-eq-floatlimit1d} holds. 
Still, their gradients may be different 
i.e. the first derivative $f'(\overline{x})$ might be nonzero, 
but, in all cases, the maximum bound is given by the inequality 
\ref{introoptim-eq-floatlimitfp1}.

\begin{proof}
The equation \ref{introoptim-eq-floatlimit1} can be expressed as 
\begin{eqnarray}
\label{introoptim-eq-floatlimit2}
|fl(f(x^\star)) - f(x^\star)| \leq \epsilon_M |f(x^\star)|.
\end{eqnarray}
Let $h> 0$ be the largest number such that 
\begin{eqnarray}
\label{introoptim-eq-floatlimit3}
|f(x^\star + h) - f(x^\star)| \leq \epsilon_M |f(x^\star)|.
\end{eqnarray}
Then, the point $\overline{x}=x^\star+h$ is associated with the best achievable 
floating point representation of the function value, since the relative difference 
between $f(\overline{x})$ and $f(x^\star)$ is smaller than the machine precision. 
That means that we will not be able to distinguish the difference between a point  
$\overline{x}$ satisfying the inequality \ref{introoptim-eq-floatlimit3}
and the exact optimum $x^\star$. This situation is presented in figure 
\ref{fig-optimum-limitedfloat}.

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{optimcond/optimum-limitedfloat.pdf}
\end{center}
\caption{Floating point representation of the function $f$ near the optimum $x^\star$.}
\label{fig-optimum-limitedfloat}
\end{figure}

Assume that the function $f$ is defined by 
\begin{eqnarray}
\label{introoptim-eq-floatlimit4b}
f(x) = a + bx + \frac{1}{2} c x^2.
\end{eqnarray}
We have $f'(x) = b+cx$ and $f''(x) = c$. Hence the following Taylor expansion 
is exact :
\begin{eqnarray}
\label{introoptim-eq-floatlimit4c}
f(x^\star + h) = f(x^\star) + hf'(x^\star) + \frac{1}{2} h^2 f''(x^\star).
\end{eqnarray}
Since, by hypothesis, the point $x^\star$ is a strong minimum, the proposition 
\ref{introoptim-necessaryunivar} implies that $f'(x^\star)=0$. 
This simplifies the previous Taylor expansion into 
\begin{eqnarray}
\label{introoptim-eq-floatlimit5}
f(x^\star + h) = f(x^\star) + \frac{1}{2} h^2 f''(x^\star).
\end{eqnarray}
We now move the term $f(x^\star)$ into the left hand side and compute the 
absolute value of the result. 
Therefore, we have 
\begin{eqnarray}
\label{introoptim-eq-floatlimit6}
|f(x^\star + h) - f(x^\star)| = \frac{1}{2} h^2 f''(x^\star).
\end{eqnarray}
Notice that there is no absolute value for the second derivative $f''(x^\star)$ 
since, by assumption, the point $x^\star$ is a strong local minimum, 
which implies that the second derivative is positive. 
We plug the floating point inequality \ref{introoptim-eq-floatlimit3}
into the previous equation and get
\begin{eqnarray}
\label{introoptim-eq-floatlimit7}
\frac{1}{2} h^2 f''(x^\star) \leq \epsilon_M |f(x^\star)|,
\end{eqnarray}
for $h=\overline{x} - x^\star$ sufficiently small.
By hypothesis, the point $x^\star$ is a strong local minimum,
so that we have $f''(x^\star)>0$. Therefore, the previous inequality 
implies the inequality \ref{introoptim-eq-floatlimit8}, which concludes 
the first part of the proof.

We now consider the following Taylor expansion of the gradient $f'$
in the neighborhood of $x^\star$:
\begin{eqnarray}
\label{introoptim-eq-floatlimitfp2}
f'(x^\star + h) = f'(x^\star) + hf''(x^\star).
\end{eqnarray}
Since $x^\star$ is a strong local minimum, we have $f'(x^\star)=0$,
which leads to 
\begin{eqnarray}
\label{introoptim-eq-floatlimitfp3}
f'(x^\star + h) = hf''(x^\star).
\end{eqnarray}
We can take the absolute value of the previous equality.
We finally plug the inequality \ref{introoptim-eq-floatlimit3} and get 
the inequality \ref{introoptim-eq-floatlimitfp1}.
\end{proof}

The equation \ref{introoptim-eq-floatlimit8} allows to gain insight into the 
best numerical accuracy which can be achieved with respect to $x^\star$,
when we consider only the function values. 
\begin{itemize}
\item If the function value at the point $x^\star$ is small, then
the right hand side of the inequality \ref{introoptim-eq-floatlimit8} will be small. 
In this case, the term is $|\overline{x} - x^\star|$ is small, which signifies that 
$\overline{x}$ is expected to be an accurate approximation of $x^\star$.
\item If the second derivative $f''(x^\star)$ is large, then 
$\overline{x}$ is expected to be an accurate approximation of $x^\star$.
\item If the second derivative $f''(x^\star)$ is small, then 
$\overline{x}$ is expected to be a poor approximation of $x^\star$.
\end{itemize}
Similar results can be derived from the inequality \ref{introoptim-eq-floatlimitfp1} 
with respect to the accuracy of the gradient of the function.
\begin{itemize}
\item If the function value at the point $x^\star$ is small, then
the first derivative $f'(\overline{x})$ is expected to be an accurate approximation of 
$f'(x^\star)=0$.
\item If the second derivative $f''(x^\star)$ is large, then 
the first derivative $f'(\overline{x})$ is expected to be a poor approximation of 
$f'(x^\star)=0$.
\item If the second derivative $f''(x^\star)$ is small, then 
the first derivative $f'(\overline{x})$ is expected to be a good approximation of 
$f'(x^\star)=0$.
\end{itemize}

In practice, it might be difficult to estimate the second derivative 
$f''(x^\star)$. In this case, we can make further assumptions about 
$f$ which will lead to another interesting feature of the accuracy of 
$\overline{x}$. Let us assume that 
\begin{eqnarray}
\label{introoptim-eq-floatlimit9}
f(x^\star)\approx 1 \textrm{ and } f''(x^\star) \approx \frac{1}{2}.
\end{eqnarray}
Under the assumptions \ref{introoptim-eq-floatlimit9}, the inequality 
\ref{introoptim-eq-floatlimit8} becomes 
\begin{eqnarray}
\label{introoptim-eq-floatlimit10}
|\overline{x} - x^\star| \leq  \sqrt{\epsilon_M}.
\end{eqnarray}

We should not be concerned with the exact values of the constants  
1 and $\frac{1}{2}$ in the equations \ref{introoptim-eq-floatlimit9}: 
in practice, only the orders of magnitude matters. 
With the relative precision of Scilab's doubles $\epsilon_M\approx 10^{-16}$, 
the right hand side of the previous equation is $\sqrt{\epsilon_M} \approx 10^{-8}$. 
The previous inequality implies that, if the function $f$ is well-scaled 
in the neighborhood of the optimum $x^\star$, then the best accuracy which 
can be expected is about \emph{half} the correct digits obtained in the function 
$f$. 

Similarly, under the same assumptions \ref{introoptim-eq-floatlimit9}, 
the inequality \ref{introoptim-eq-floatlimitfp1} implies 
\begin{eqnarray}
\label{introoptim-eq-floatlimitgr10}
|f'(\overline{x})| \leq  \sqrt{\epsilon_M}.
\end{eqnarray}
This means that the accuracy of the norm of the gradient is approximetely
half the correct digits of the floating point numbers at use.

\begin{example}
Let us consider the function $f:\RR\rightarrow \RR$ defined 
by $f(x) = 1+x^2$ for any $x\in\RR$. The minimum of this function is reached 
at $x^\star = 0$, where we have $f(x^\star)=1$, 
$f'(x^\star)=0$ and $f''(x^\star)=2$. 
In the following script, we define this function
and generate the plot presented in the figure \ref{fig-limitedfloat-example1}.
\lstset{language=scilabscript}
\begin{lstlisting}
function y = f ( x )
  y = 1 + x**2
endfunction
x = linspace(-1,1,100);
y = f ( x ) ;
plot ( x , y )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/limitedfloat-example1.pdf}
\end{center}
\caption{Plot of the function $f(x) = 1+x^2$.}
\label{fig-limitedfloat-example1}
\end{figure}

In order to see the local behavior of the function $f$ in the 
neighborhood of zero, we plot the function in the 
range $[-3\cdot 10^{-8} , 3\cdot 10^{-8}]$. 
These $x$-values are extremely small and we may have trouble to read 
the labels. 
This is why we scale the $x$-values with the $3\cdot 10^{7}$ factor. 
In this interval, the function value is close to one and 
this is why we have to shift the data and rescale the y-values
with the $10^{16}$ factor. This leads to the the following script, 
which produces the plot presented in figure \ref{fig-limitedfloat-example2}.
\lstset{language=scilabscript}
\begin{lstlisting}
x = linspace(-3.e-8,3.e-8,100);
y = f ( x ) ;
plot ( x*3.e7 , (y-1)*1.e16 , "o" )
h = gcf();
h.children.data_bounds = [
   -1.   -1
    1.    10
  ];
xtitle ( "Function f(x)=1 + x^2 in the neighborhood of x=0" , ..
  "x * 3.e7" , "(y-1)*1.e16" )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/limitedfloat-example2.pdf}
\end{center}
\caption{Plot of the function $f(x) = 1+x^2$ in the neighborhood of $x^\star=0$.}
\label{fig-limitedfloat-example2}
\end{figure}

The behavior presented in the figure \ref{fig-limitedfloat-example2} 
corresponds to the expected behavior produced by the floating point 
limitations associated with doubles. 
Hence, by the inequality \ref{introoptim-eq-floatlimit8},
the maximum accuracy which can be expected for this particular function 
is $|\overline{x}-x^\star| = \sqrt{\epsilon_M}\approx 10^{-8}$.

We now consider the values of the first derivatives in the 
same interval. 
The following Scilab function defines the first derivative.
\lstset{language=scilabscript}
\begin{lstlisting}
function y = fp ( x )
  y = 2 * x
endfunction
\end{lstlisting}
The following script computes several values of the first derivative 
in the same interval as previously.
\lstset{language=scilabscript}
\begin{lstlisting}
x = linspace(-3.e-8,3.e-8,10);
y = fp ( x );
[x' y']
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[x' y']
 ans  =
  - 3.000D-08  - 6.000D-08  
  - 2.333D-08  - 4.667D-08  
  - 1.667D-08  - 3.333D-08  
  - 1.000D-08  - 2.000D-08  
  - 3.333D-09  - 6.667D-09  
    3.333D-09    6.667D-09  
    1.000D-08    2.000D-08  
    1.667D-08    3.333D-08  
    2.333D-08    4.667D-08  
    3.000D-08    6.000D-08  
\end{lstlisting}
As we can see, the first derivative is far from being zero.
Hence, a method which uses the gradient may be able to get 
a better accuracy than a method using the function values only.
\end{example}

\begin{example}
Let us consider the function $f:\RR\rightarrow \RR$ defined 
by $f(x) = x^2$ for any $x\in\RR$. The minimum of this function is reached 
at $x^\star = 0$, where we have $f(x^\star)=0$, 
$f'(x^\star)=0$ and $f''(x^\star)=2$. In this case, the function value 
at $x^\star$ is zero, which leads to an extremely accurate 
right hand side in the inequality \ref{introoptim-eq-floatlimit8}, as 
we are going to see.
In the following script, we analyze the function $f$ in the neighborhood 
of zero. We consider the $x$-interval $[-3\cdot 10^{-162},3\cdot 10^{-162}]$. 
Then we compute the corresponding $y$ values and display them in the 
console.
\lstset{language=scilabscript}
\begin{lstlisting}
function y = f ( x )
  y = x**2
endfunction
format("e",25)
x = linspace(-3.e-162,3.e-162,10);
y = myquadratic ( x ) ;
[x' y']
\end{lstlisting}
The previous script produces the following output, where the 
first column is the column of $x$ values and the second 
column is the column of $y=f(x)$ values.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[x' y']
 ans  =
 
   1.0-242 *
 
  - 3.000000000000001449D+80    9.881312916824936069D-82  
  - 2.333333333333334694D+80    4.940656458412468034D-82  
  - 1.666666666666667676D+80    4.940656458412468034D-82  
  - 1.000000000000000395D+80    0.                        
  - 3.333333333333336406D+79    0.                        
    3.333333333333336406D+79    0.                        
    1.000000000000000790D+80    0.                        
    1.666666666666668203D+80    4.940656458412468034D-82  
    2.333333333333334431D+80    4.940656458412468034D-82  
    3.000000000000001449D+80    9.881312916824936069D-82  
\end{lstlisting}
This output corresponds to the expected results on a floating 
point machine which provides denormalized floating point numbers.
Indeed, if $|x|<10^{-162}=10^{-242}\cdot 10^{80}$, 
then $x^2<10^{-324}$, which cannot 
be represented as a double floating point number. An underflow occurs 
for such a small number, which is therefore represented as zero. 
This confirms that, if the function value at optimum is zero, 
then a very good accuracy can be obtained with respect to $\overline{x}$.
\end{example}

The following proposition extends the previous proposition 
\ref{introoptim-prop-floatlim1} to multivariate functions.

\begin{proposition}
\emph{(Limitation of floating point accuracy - Multivariate case)}
\label{introoptim-prop-floatmv1}
Assume that $f:\RR^n\rightarrow\RR$ is a quadratic 
multivariate function and that $\bx^\star \in\RR^n$ is a strong local 
minimum of the function $f$. 
Assume that the floating point system is associated with the 
machine epsilon $\epsilon_M>0$ and that the floating point function value 
at the point $x^\star$ satisfies 
\begin{eqnarray}
\label{introoptim-prop-floatmv1b}
fl(f(\bx^\star)) = f(\bx^\star) ( 1+\delta ),
\end{eqnarray}
where $|\delta| \leq \epsilon_M$. 
Assume that the point $\overline{\bx} \in\RR^n$ is so that $\overline{\bx} = \bx^\star + 
\bp$, where $\bp\in\RR^n$ is an eigenvector of the Hessian 
matrix $H(\bx^\star)$ associated with the eigenvalue $\lambda(\bx^\star) >0$. 
If $\overline{\bx}$ satisfies 
\begin{eqnarray}
\label{introoptim-prop-floatmv2}
\|\overline{\bx} - \bx^\star\| 
\leq  \sqrt{\frac{2 \epsilon_M |f(\bx^\star)|}{\lambda(\bx^\star)}},
\end{eqnarray}
therefore, 
\begin{eqnarray}
\label{introoptim-prop-floatmv1d}
fl(f(\overline{\bx})) = fl(f(\bx^\star)).
\end{eqnarray}
For such a point, the gradient $\bg(\overline{\bx})$ satisfies
\begin{eqnarray}
\label{introoptim-prop-floatmv3}
\|\bg(\overline{\bx})\| 
\leq  \sqrt{2 \epsilon_M |f(\bx^\star)|\lambda(\bx^\star)}.
\end{eqnarray}
\end{proposition}

The proof of the previous proposition is given as the exercise 
\ref{introoptim-exer-floatmv1}. 

In the previous proposition, the role of the eigenvalue is the same as the role of the 
second derivative in the univariate case. Its magnitude measures 
the local curvature of the function in the direction of the 
eigenvector. Hence, if we consider the accuracy in the direction
of an eigenvector $\bu$ associated with a large eigenvalue $\lambda$, 
then the right hand side of \ref{introoptim-prop-floatmv2} is small, 
indicating that we can expect a good accuracy. Instead, a poor accuracy 
is expected in the direction of an eigenvector associated with a 
small eigenvalue. Hence, we are interested in the ratio between the 
largest and the smallest eigenvalues. This is the conditioning 
of the Hessian matrix and will be reviewed in the next 
section.

The previous results lead to a practical way of setting the 
convergence tolerances of optimization solvers based on function 
values only.  These algorithms are often called \emph{direct search}
methods. It is very common that the solver let the user set the 
relative or absolute tolerance with respect to $\overline{\bx}$. 
The previous analysis shows us that there is no point in setting 
this tolerance at a too low value. By default, that is, if 
we do not have any information about the function value or 
the conditioning of the Hessian matrix at optimum, we should set the 
relative tolerance for the point $\overline{\bx}$ at the value $\sqrt{\epsilon_M}$. 
For such an algorithm, the gradient at the computed optimum $\overline{\bx}$
is always given by the equation \ref{introoptim-prop-floatmv3}. 
By opposition, algorithms based on the gradient $\bg(\overline{x})$ 
may have a chance to compute a more accurate optimum. This is because 
the algorithm may progress further until the equation $\bg(\bx^\star)=0$ is 
solved with a better accuracy than the equation \ref{introoptim-prop-floatmv3} 
predicts.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Condition number of the Hessian matrix}
\index{condition number}

In this section, we focus on the condition number of the Hessian matrix, 
which measures the sensitivity of the change of function value 
in the direction of the eigenvectors. We first consider quadratic 
functions. 
Then we consider the nonlinear objective function 
associated with Rosenbrock's problem.

Let us consider the quadratic function 
\begin{eqnarray}
\label{optimcond-quadratic2}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bx\in\RR^n$, the vector $\bb\in\RR^n$ is a given vector and 
$H$ is a $n\times n$ matrix. We assume that the matrix $H$ is symetric 
positive definite. Let us introduce the eigenvalues $\lambda_i > 0$
and the eigenvectors $\bu_i\in\RR^n$ for $i=1,2,\ldots,n$.
We assume that the eigenvalues are sorted in increasing order, that is,
$0<\lambda_1< \lambda_2< \ldots <\lambda_n$. 
The 2-norm condition number of the matrix $H$ is the ratio 
between the largest and the smallest eigenvalues, i.e. 
\begin{eqnarray}
\label{optimcond-conditionH}
cond(H) = \frac{\lambda_n}{\lambda_1}.
\end{eqnarray}
The following two examples illustrates the local behavior of the 
quadratic function depending on the value of the condition number.

\begin{example}
Consider the quadratic function defined by the equation \ref{optimcond-quadratic2} 
where $\bb = (0,0)^T$ and 
\begin{eqnarray}
H=\left(\begin{array}{cc}
1 & 0\\
0 & 1
\end{array}\right)
\end{eqnarray}
The eigenvalues of the identity matrix are $\lambda_1=\lambda_2 = 1$ which 
leads to the condition number $cond(H) = 1$. 
The following Scilab script defines the quadratic function 
and plots the contours of the function. Notice that we configure 
the size of the axes so that the graphics is plot in a square 
frame.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadwellcond ( x1 , x2 )
  H = [
    1 0
    0 1
    ]
  x = [x1 x2]'
  f = 0.5 * x' * H * x;
endfunction
xdata = linspace(-1,1,100);
ydata = linspace(-1,1,100);
contour ( xdata , ydata , quadwellcond , [0.1 0.2 0.4 0.6 0.8])
h = gcf();
h.axes_size = [500 500]
\end{lstlisting}
The previous script produces the plot presented in figure 
\ref{fig-optimcond-condequalone}. 
We notice that the contours are circles. 
Therefore, a perturbation of the point $\bx^\star=(0,0)^T$ produces a change in 
$f$ which does not depend on the direction of the perturbation.
\end{example}


\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/quadratic-cond-well.pdf}
\end{center}
\caption{Plot of a quadratic function with $cond(H)=1$.}
\label{fig-optimcond-condequalone}
\end{figure}

\begin{example}
Consider the quadratic function \ref{optimcond-quadratic2} 
where $\bb = (0,0)^T$ and 
\begin{eqnarray}
H=\left(\begin{array}{cc}
1 & 0\\
0 & 10
\end{array}\right)
\end{eqnarray}
The eigenvalues of the identity matrix are $\lambda_1=1$ and $\lambda_2 = 10$ which 
leads to the condition number $cond(H) = 10$. 
The following Scilab script defines the quadratic function 
and plots the contours of the function. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadillcond ( x1 , x2 )
  H = [
    1 0
    0 10
    ]
  x = [x1 x2]'
  f = 0.5 * x' * H * x;
endfunction
xdata = linspace(-1,1,100);
ydata = linspace(-1,1,100);
contour ( xdata , ydata , quadillcond , [0.1 0.2 0.4 0.6 0.8])
h = gcf();
h.axes_size = [500 500]
h.children.data_bounds = [
   -1.  -1
    1.   1
]
\end{lstlisting}
The previous script produces the plot presented in figure 
\ref{fig-optimcond-condequalten}. 
We notice that the contours are ellipsoids. 
Therefore, a perturbation of the point $\bx^\star=(0,0)^T$ produces a change in 
$f(\bx)$ which does depend on the direction of the perturbation.
If the direction $\bp$ of the perturbation is colinear to the 
first eigenvector $\bu_1$, then the change of function value will 
be moderate, since $\lambda_1 = 1$. Instead, if the direction of the 
perturbation $\bp$ is colinear to the second eigenvector $\bu_2$, then
the change of function value will be large, since $\lambda_2 = 10$.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/quadratic-cond-ill.pdf}
\end{center}
\caption{Plot of a quadratic function with $cond(H)=10$.}
\label{fig-optimcond-condequalten}
\end{figure}

In extreme cases, the condition number of the Hessian matrix is so large
that the contours of the function seem to be parallel lines.

The previous analysis can fail if the function has discontinuous 
second derivatives or if the Hessian matrix has zero eigenvalues 
at optimum. For example, the function $f(\bx)=x_1^4 + x_2^4$ has 
a unique global optimum $\bx^\star=(0,0)^T$ where the Hessian matrix 
is zero. In this case, we would need higher order derivatives, which 
may be unavailable in practice.

In the following example, we explore the effect of a badly conditioned 
Hessian matrix. The analysis is based on a perturbation of the optimum
point $\bx^\star$. 

\begin{example}
\label{examp-conditionquad}
Consider the function $f:\RR^2 \rightarrow \RR$ defined by 
\begin{eqnarray}
\label{optimcond-xmpl-badquad1}
f(\bx) = 1 + (x_1 - 1)^2 + 10^{-6}(x_2-1)^2.
\end{eqnarray}
Its gradient is 
\begin{eqnarray}
\bg(\bx) 
= \left(
\begin{array}{c}
2 (x_1 - 1)\\
2.10^{-6}(x_2-1)
\end{array}
\right).
\end{eqnarray}
The Hessian matrix is 
\begin{eqnarray}
H(\bx) 
= \left(
\begin{array}{cc}
2 & 0 \\
0 & 2.10^{-6}
\end{array}
\right).
\end{eqnarray}
The Hessian matrix is positive definitive and its condition
number is $10^6$. The optimum is $\bx^\star = (1,1)^T$. 
The following script allows to produce the contour plot 
presented in figure \ref{fig-quadbadcond}. This plot 
allows to see the behavior of the function in the neighborhood 
of the optimum. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadbadcond ( x1 , x2 )
  x = [x1 x2]
  f = 1 + ( x(1) - 1 )^2 + 1.e-6 * (x(2) - 1)^2
endfunction
x = linspace(0.998,1.002,50);
y = linspace(0,3,50);
contour ( x , y , quadbadcond , 5 )
\end{lstlisting}
Notice that the function values are so close to one that the 
graphics system displays the label "1" on each contour. 
Notice also that the interval of $x_1$ values is reduced with 
respect to the interval of $x_2$ values.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{optimcond/badcond-perturbation.pdf}
\end{center}
\caption{Contour plot of a badly conditioned quadratic.}
\label{fig-quadbadcond}
\end{figure}

We now want to compare two points, computed by perturbation of the 
optimum along the eigenvectors. In the following session, we 
define the optimum and the two eigenvectors $\bu_1=(1,0)^T$ and 
$\bu_2=(0,1)^T$. 
Then we define the two points $\bx_t = \bx^\star + 10^{-3} \bu_1 = (1,1+10^{-3})^T$
and $\bx_s = \bx^\star + \bu_2 = (1,2)^T$. Notice that the point $\bx_t$ is 
much closer to the optimum than $\bx_s$.
\lstset{language=scilabscript}
\begin{lstlisting}
xopt = [1 1]';
u1 = [1 0]';
u2 = [0 1]';
xt = xopt + 1.e-3 * u1;
xs = xopt + u2;
plot ( xt(1) , xt(2) , "b*" )
plot ( xs(1) , xs(2) , "ro" )
\end{lstlisting}
We now define the following function, which allows to compute the 
function value, the gradient and the Hessian.
\lstset{language=scilabscript}
\begin{lstlisting}
function [ f , g , H ] = qbc ( x )
  f = 1 + ( x(1) - 1 )^2 + 1.e-6 * (x(2) - 1)^2
  g = [
    2 * ( x(1) - 1 )
    2 * 1.e-6 * (x(2) - 1)
    ]
  H = [
    2 0
    0 2*1.e-6
    ]
endfunction
\end{lstlisting}
The function values and the gradient at these points are computed in 
the following session. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->[ f , g , H ] = qbc ( xt );
-->disp([f norm(g)])
    1.000001    0.002  
-->[ f , g , H ] = qbc ( xs );
-->disp([f norm(g)])
    1.000001    0.000002  
\end{lstlisting}
We see that the function values are equal but $\|\bg(\bx_t)\|_2 > \|\bg(\bx_s)\|_2$.
From the gradient point of view, the point $\bx_s$ is 
"better", even if the point $\bx_t$ is much closer to the optimum.
\end{example}

We now analyze the conditioning of Rosenbrock's function.

\begin{example}
\index{Rosenbrock H.H.}
Let us consider Rosenbrock's function defined by the equation 
\ref{introoptim-rosenbrock}. Let us compute the 
condition number of the Hessian matrix at the optimum 
$\bx^\star=(1,1)^T$. 

We have already seen that the eigenvalues of this function 
at the point $\bx^\star$ are $(\lambda_1,\lambda_2)\approx (0.3993631 , 1001.6006)$.
Let us denote by $(\bv_1,\bv_2)$ the corresponding eigenvectors.
The 2-norm condition number of the Hessian matrix is approximately equal to 
$\lambda_2/\lambda_1 \approx 2507.9949$.
This means that a variation along the eigenvector $\bv_1$ 
(i.e. $\bx+\alpha\bv_1$, for $\alpha \in \RR$) produces a much 
smaller change of function value than a variation 
along the eigenvector $\bv_2$. 

This ill-conditioning appears clearly in the contour plot of the 
figure \ref{fig-answer-rosenbrockcontoursneigh}.
The eigenvalues are so different in magnitude that the lines appear
to be parallel. 

We can apply the proposition \ref{introoptim-prop-floatmv1} which 
states the accuracy of the computed optimum $\overline{\bx}$.
The ill-conditioning of Rosenbrock's function does not limit the 
accuracy of the result. This is because the function value 
at optimum $\bx^\star$ is $f(\bx^\star)=0$. Hence, the right 
hand side of the inequality \ref{introoptim-prop-floatmv2} is zero.
Therefore, full accuracy can be expected in the case of Rosenbrock's function.
\end{example}

We finally consider the following proposition, which gives a 
sensitivity analysis of a perturbation of the optimum in the direction
of the eigenvectors. This extends the result of the example \ref{examp-conditionquad}.


\begin{proposition}
\emph{(Sensitivity analysis near the optimum)}
\label{optimcond-prop-sensitivitiyanalysis}
Assume that $f:\RR^n \rightarrow \RR$ is a quadratic function
\begin{eqnarray}
\label{optimcond-exer-sensitivityan1}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bb\in\RR^n$ and $H$ is a $n\times n$ real symmetric positive definite 
matrix. Assume that $\bx^\star\in\RR^n$ is the global 
minimum of this convex function. Let us denote by $\{\lambda_i\}_{i=1,n}$
the eigenvalues of the matrix $H$ and let us order them such that 
$0< \lambda_1 < \lambda_2 < \ldots < \lambda_n$. Let us denote by $\{\bu_i\}_{i=1,n}$
the normalized eigenvectors of the matrix $H$. 
There exists two points $\bx_s,\bx_t\in\RR^n$ 
such that $\bx_s = \bx^\star + s \bu_1$ and $\bx_t = \bx^\star + t\bu_n$
with $s,t>0$ which satisfy the equations
\begin{eqnarray}
\label{optimcond-exer-sensitivityan1b}
f(\bx_s) &=& f(\bx_t), \\
\|\bx_s - \bx^\star\| &=& \|\bx_t - \bx^\star\| \sqrt{\frac{\lambda_n}{\lambda_1}},
\label{optimcond-exer-sensitivityan2}
\end{eqnarray}
and 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan3}
\|\bg(\bx_t)\| = \|\bg(\bx_s)\| \sqrt{\frac{\lambda_n}{\lambda_1}}.
\end{eqnarray}
\end{proposition}

The proof of this proposition is given in exercise \ref{optimcond-exer-sensitivityan}.

The inequality $\lambda_1 < \lambda_n$ allows to simplifies the inequalities \ref{optimcond-exer-sensitivityan2}
and \ref{optimcond-exer-sensitivityan3} into 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan15}
\|\bx_s - \bx^\star\| > \|\bx_t - \bx^\star\| 
\end{eqnarray}
and 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan16}
\|\bg(\bx_t)\| > \|\bg(\bx_s)\|.
\end{eqnarray}

The inequality \ref{optimcond-exer-sensitivityan15} states that 
$\bx_t$ is closer to the optimum (i.e. $\bx_t$ is "better"), but inequality \ref{optimcond-exer-sensitivityan16}
states that the gradient at $\bx_s$ is closer to zero (i.e. $\bx_s$ is "better"). 
This situation is presented in the figure \ref{fig-sensinearoptim}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{optimcond/sensitivity-nearoptim.pdf}
\end{center}
\caption{Sensitivity analysis in the neighborhood of the optimum $\bx^\star$. - 
Notice that, the point $\bx_t$ is close to the optimum but is associated
with a large gradient. 
On the other hand, the point $\bx_s$ is away from the optimum but is associated
with a small gradient.}
\label{fig-sensinearoptim}
\end{figure}

The rate at which these inequalities evolve is governed by 
$\sqrt{\frac{\lambda_n}{\lambda_1}}=\sqrt{cond(H)}$.
Hence, if the Hessian matrix is ill-conditioned, then the left and right 
hand sides of the inequalities are more and more different. 

The previous analysis leads to the following comments which focus 
on the way that an optimization algorithm may be able to terminate the search. 
From another point of view, we question the accuracy that we can expect 
from an optimization algorithm. 
Some algorithms rely on the norm of the gradient or the evolution of the 
point $\bx_n$ corresponding to the iteration $n$ of the algorithm. 
The inequalities \ref{optimcond-exer-sensitivityan2} and 
\ref{optimcond-exer-sensitivityan3} show that, if the condition number of the Hessian matrix is 
large, the gradient at a computed point $\overline{\bx}$ might be close to zero even if 
the point $\overline{\bx}$ is not close to the optimum $\bx^\star$. 
This is especially true if the vector $\overline{\bx} - \bx^\star$ is in the direction of the eigenvector 
$\bu_1$ associated with the lowest eigenvalue $\lambda_1$. 
By contrast, a point for which the gradient is large might be very close to the optimum, 
provided that the vector $\overline{\bx} - \bx^\star$ is in the direction of the eigenvector 
$\bu_n$ associated with the largest eigenvalue $\lambda_n$.
Because of the proposition \ref{introoptim-prop-floatmv1}, using the function value 
only might be unsafe and may lead to inaccurate optimas. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Notes and references}



The optimality conditions in section \ref{introoptim-section-optimalityconditions},
are inspired from Gill, Murray and Wright 
\cite{Gill81MurrayWright}, who present also optimality conditions for 
linearly constrained optimization
and nonlinearly constrained optimization.
A description of unconstrained optimality conditions of a 
multivariate function is presented in Kelley's book \cite{OtimizationKelley1999},
section 1.3, "Necessary conditions".
Unconstrained optimality conditions are presented in Nocedal and Wright 
\cite{numericaloptimization}, chapter 2, "Recognizing a local optimum".

The results regarding the effect of rounding errors in optimization 
presented in section \ref{introoptim-section-floatlimit} are presented 
in Gill, Murray and Wright \cite{Gill81MurrayWright}, 
Section 8.2.2, "The accuracy of the solution", p. 301. Their discussion 
focuses on multivariate optimization. Richard Brent presents this topic 
in two sections of \cite{Brent73algorithmsfor}. In the 
Chapter 4, "An algorithm with guaranteed convergence for finding a zero 
of a function", Section 2, "Fundamental limitations because of rounding errors", 
p. 63, Brent focuses on univariate optimization and presents a diagram 
which is similar to the figure \ref{fig-optimum-limitedfloat}.
In the Chapter 7, "A new algorithm for minimizing a function of 
several variables without calculating derivatives", Section 2, 
"The effect of rounding errors", p. 122, Brent focuses on multivariate 
optimization. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\subsection{Exercises}
\label{introoptim-section-exeroptimality}

\begin{exercise}[Taylor expansion of a quadratic function]
\label{introoptim-exer-taylorquad}
Consider the function $f:\RR^n \rightarrow \RR$ defined by 
\begin{eqnarray}
\label{introoptim-exer-taylorquad1}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bx\in\RR^n$, the vector $\bb\in\RR^n$ is a given vector and 
$H$ is a $n\times n$ symetric matrix. 
Prove that for any vector $\bp\in\RR^n$ and any scalar $\alpha \in\RR$, we have
\begin{eqnarray}
\label{introoptim-exer-taylorquad2}
f(\bx+\alpha\bp) = f(\bx) + \alpha\bp^T(H\bx+\bb) + \frac{1}{2} \alpha^2 \bp^T H \bp.
\end{eqnarray}
\end{exercise}

\begin{exercise}[Rosenbrock's function in the eigenvectors directions]
\label{optimcond-exer-rosendirec}
Consider Rosenbrock's function defined by \ref{introoptim-rosenbrock}.
Create a plot representing the function $\phi_i(\alpha) = f(\bx^\star + \alpha \bu_i)$
for $i=1,2$ in the interval $\alpha\in[0,1]$. 
Compare with the quadratic model given by the equation \ref{introoptim-quadratictaylor3}.
\end{exercise}


\begin{exercise}[Limitation of floating point accuracy - Multivariate case]
\label{introoptim-exer-floatmv1}
Proove the proposition \ref{introoptim-prop-floatmv1}.
\end{exercise}

\begin{exercise}[Sensitivity analysis of the optimum]
\label{optimcond-exer-sensitivityan}
Prove the proposition \ref{optimcond-prop-sensitivitiyanalysis}.
\end{exercise}

\begin{exercise}[Sensitivity analysis for Rosenbrock's function]
\label{optimcond-exer-sensanrosenbrock}
Consider Rosenbrock's function defined by \ref{introoptim-rosenbrock}.
Notice that the proposition \ref{optimcond-prop-sensitivitiyanalysis} cannot be 
applied directly, since Rosenbrock's function is not quadratic. 
But, by Taylor's theorem, it can be closely approximated by a quadratic function in the 
neighborhood of the optimum $\bx^\star$. 
Let us denote by $\lambda_{1,2}$ the eigenvalues of the Hessian matrix $H(\bx^\star)$ of 
Rosenbrock's function with $0<\lambda_1<\lambda_2$. Let us denote by 
$\bu_{1,2}$ their associated eigenvectors. 
Find $s,t>0$ such that the points $\bx^\star + s\bu_1$ and 
$\bx^\star + t\bu_2$ sastisfy the equations \ref{optimcond-exer-sensitivityan15}
and \ref{optimcond-exer-sensitivityan16}.
\end{exercise}

\end{footnotesize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Modelling}
\label{introoptim-section-modelling}

It may happen that we have to solve a problem which formulation
does not exactly fit the numerical method at hand. 
It may also happen that the optimization problem is the result of a \emph{choice}, where
a function is chosen with a particular form instead of another. 
In this section, we describe how 
to reformulate a problem into another mathematically equivalent 
problem. The difficult part is that the problems may be 
mathematically equivalent, but still of very different conditioning,
i.e. one problem may be very difficult to solve while the other 
may be easier. In this section, we analyze such modeling issues so that 
transformation of problems can be the result of an aware choice.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Minimum or maximum}

Assume that one algorithm is able to find the minimum of the 
unconstrained problem
\begin{eqnarray}
\label{introoptim-problem-unconstmin}
&&\min_{\bx \in \RR^n} f(\bx).
\end{eqnarray}
Suppose now that we want to find the maximum of the unconstrained 
problem
\begin{eqnarray}
\label{introoptim-problem-unconstmax}
&&\max_{\bx \in \RR^n} \overline{f}(\bx).
\end{eqnarray}
It is easy to reformulate the problem \ref{introoptim-problem-unconstmax}
into formulation \ref{introoptim-problem-unconstmin}, by minimizing the function 
$f = -\overline{f}$.
This modification of the optimization problem does not change the eigenvalues of the 
Hessian matrix (both matrices are simply opposite with each other). Therefore, 
the difficulty of the optimization problem is not changed.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Sign of the inequality constraints}

Consider the two constrained optimization problems,
the first having positive constraints
\begin{eqnarray}
\label{introoptim-problem-positiveconst}
&&\min_{\bx \in \RR^n} f(\bx),\\
&s.t.&h_i(\bx) \geq 0, \qquad i=1,m,
\end{eqnarray}
and the second having negative constraints
\begin{eqnarray}
\label{introoptim-problem-negativeconst}
&&\min_{\bx \in \RR^n} f(\bx),\\
&s.t.&\overline{h}_i(\bx) \leq 0, \qquad i=1,m.
\end{eqnarray}
The two problems are strictly equivalent since we  
can always choose $\overline{h}=-h$. Therefore, the difficulty 
of the optimization problem is not changed, since it only modifies the 
side of the bound constraint. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Slack variables}
\index{slack variables}

Another classical transformation is based on the introduction
of \emph{slack} variables.
Suppose that one algorithm is able to find the solution of the 
following problem with a nonlinear objective and 
nonlinear inequality constraints 
\begin{eqnarray}
\label{introoptim-problem-ineqconstpos1}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_i(\bx) \geq 0, \qquad i=1,m,
\label{introoptim-problem-ineqconstpos2}
\end{eqnarray}
where the $h_i$ functions are nonlinear inequality constraints.
Suppose now that the problem to solve is to find the 
minimum of an objective function with equality constraints
and bound constraints 
\begin{eqnarray}
\label{introoptim-problem-ineqconstzero1}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_i(\bx) = 0, \qquad i=1,m,\\
&    &x_{i,L} \leq x_i \leq x_{i,U}, \qquad i=1,n,
\label{introoptim-problem-ineqconstzero3}
\end{eqnarray}
where the $h_i$ functions are non linear equality constraints,
and $x_{i,L} ,  x_{i,U} \in \RR$ are bounds.
It is easy to reformulate problem \ref{introoptim-problem-ineqconstpos1}--\ref{introoptim-problem-ineqconstpos2} 
into the formulation \ref{introoptim-problem-ineqconstzero1}--\ref{introoptim-problem-ineqconstzero3}, by introducing 
the \emph{slack variables} $\{s_i\}_{i=1,m}$ so that the problem to solve 
is 
\begin{eqnarray}
\label{introoptim-problem-ineqconstslack}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_i(\bx) - s_i = 0, \qquad i=1,m,\\
&    &s_i \geq 0, \qquad i=1,m.
\end{eqnarray}
The unknown of the new problem \ref{introoptim-problem-ineqconstslack} 
is now $\overline{\bx}=(x_1,\ldots,x_n,s_1, \ldots s_m)^T$ so that the total
number of unknowns increased from $n$ to $n+m$.
This method does not increase the numerical difficulty 
to solve the problem, because the set of active constraints 
is exactly the same in both problems. The Hessian matrix of the 
cost function is not modified, which is another argument in favor 
of this transformation method.
% TODO : demander a Gilbert

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\subsection{Inequality and equality constraints}
Suppose that one algorithm is able to find the solution of the 
following problem with a nonlinear objective and 
nonlinear inequalities 
\begin{eqnarray}
\label{introoptim-problem-ineqconst}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_{i,L} \leq h_i(\bx) \leq h_{i,U}, \qquad i=1,m,
\end{eqnarray}
where the $h_i$ functions are nonlinear inequality constraints.
Suppose now that the problem to solve is to find the 
minimum of an objective function with equality constraints
\begin{eqnarray}
\label{introoptim-problem-eqconst}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_i(x) = 0, \qquad i=1,m,
\end{eqnarray}
where the $h_i$ functions are non linear equality constraints.
It is easy to reformulate the problem \ref{introoptim-problem-eqconst}
into the formulation \ref{introoptim-problem-ineqconst}, by taking 
$h_{i,L} = h_{i,U} = 0$.

% TODO: demander a Gilbert


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Issues with transformations}

% TODO :Gill \& Murray counter examples example 7.3, p 269
In this section, we present a method 
which may transforms an easy optimization problem into a difficult problem.
This example shows that not all transformations are safe so that 
modeling issues should be considered with caution. 

The transformations that we are going to analyze allows to 
eliminate simple bounds in an optimization
problem, by introducing squared variables.
Consider the following optimization problem, with bound constraints.

\begin{eqnarray}
\label{introoptim-easyproblem}
&&\min_{\bx\in\RR^n} f(\bx)\\
&&\textrm{subject to } x_i\geq 0, \qquad i=1,n
\end{eqnarray}

We consider the following unconstrained problem
\begin{eqnarray}
\label{introoptim-difficultproblem}
&&\min_{\bw\in\RR^n} \overline{f}(\bw)
\end{eqnarray}
where $\overline{f}(\bw)=f(\bx)$ and $x_i=w_i^2$.
Obviously, squared variables are positive, which implies 
that the second problem is unconstrained.

The whole point is that this transformation \emph{modifies}
the cost function, and therefore modifies its Hessian matrix.
In the following example, we consider a particular function 
$f$ associated with an Hessian matrix which is associated 
with an eigenvalue matrix which has a small condition 
number, because the constraint is active at optimum. We will prove 
that the transformed problem is associated with an Hessian matrix 
which may become singular at optimum.

Consider the bound constrained optimization problem
\begin{eqnarray}
\label{introoptim-easyproblem2}
&&\min_{\bx\in\RR^n} f(\bx)=x_1^{5/2} + (x_2+1)^2\\
&&\textrm{subject to } x_1\geq 0.
\end{eqnarray}
The solution is $\bx^\star=(0,-1)^T$.
The following script produces the contours of the cost function $f$ 
which are presented in the figure \ref{fig-introoptim-contourseasy}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = myfunction ( x1 , x2 )
  f = x1**2.5 + (x2+1)**2;
endfunction
x = linspace(0,1,100);
y = linspace(-3,1,100);
contour ( x , y , myfunction , [0.1 0.5 1 2 3])
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm,angle=0]{optimcond/introoptim-easyproblem.pdf}
\caption{Contours of the function $f(\bx)=x_1^{5/2} + (x_2+1)^2$ in the range $[0,1]\times[-3,1]$.}
\label{fig-introoptim-contourseasy}
\end{center}
\end{figure}

The gradient of the cost function $f$ is 
\begin{eqnarray}
\bg(\bx) = \left(
\begin{array}{c}
\frac{5}{2}x_1^{3/2} \\
2x_2 + 2
\end{array}
\right)
\end{eqnarray}
and the Hessian matrix of the function $f$ is 
\begin{eqnarray}
H(\bw) = 
\left(
\begin{array}{cc}
\frac{15}{4} x_1^{1/2} & 0\\
0 & 2
\end{array}
\right).
\end{eqnarray}
The Hessian matrix $H$ of the function $f$ is therefore 
singular at the optimum $\bx^\star=(0,-1)^T$.
But the bound constraint $x_1\geq 0$ is active at optimum, 
which implies that the solution $\bx^\star$ satisfies the 
equality $x_1=0$. Hence, this variable is eliminated from the function $f$, the gradient $\bg$ and 
the Hessian matrix $H$.
More precisely, the projected function is 
\begin{eqnarray}
f_p(x_2) &=& (x_2+1)^2 
\end{eqnarray}
The projected gradient is $\bg_p(x_2) = 2(x_2 + 1)$ and 
and the projected Hessian matrix is $H_p(x_2) = 2$.
All in all, the Hessian matrix is associated with a condition number equal to $2$ and 
this is why the unmodified problem is easy to solve.

The transformed problem is 
\begin{eqnarray}
\label{introoptim-difficultproblem2}
&&\min_{\bw\in\RR^2} \overline{f}(\bw)=(w_1^2)^{5/2} + (w_2+1)^2,
\end{eqnarray}
where $w_1 = x_1^2$ and $w_2=x_2$. 
Notice that if the term $(w_1^2)^{5/2}$ is computed as $w_1^5+ (w_2+1)^2$,
the problem has no solution since the cost function $\overline{f}$ is 
unbounded (the power five is odd). 
This is why the term $(w_1^2)^{5/2}$ must be computed by 
squaring first $w_1$, and then powering to $5/2$.
The following script produces the contours of the function $\overline{f}$ which 
are presented in the figure \ref{fig-introoptim-contoursdifficult}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = transformed ( w1 , w2 )
  f = (w1**2)**2.5 + (w2+1)**2;
endfunction
x = linspace(-1,1,100);
y = linspace(-3,1,100);
contour ( x , y , transformed , [0.1 0.5 1 2 3])
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm,angle=0]{optimcond/introoptim-difficultproblem.pdf}
\caption{Contours of the function $\overline{f}(\bw)=(w_1^2)^{5/2} + (x_2+1)^2$ in the range $[-1,1]\times[-3,1]$.}
\label{fig-introoptim-contoursdifficult}
\end{center}
\end{figure}

The gradient of the modified function $\overline{f}$ is 
\begin{eqnarray}
\overline{\bg}(\bw) = \left(
\begin{array}{c}
5 w_1^4 \\
2(w_2 + 1)
\end{array}
\right)
\end{eqnarray}
Hessian matrix  is 
\begin{eqnarray}
\overline{H}(\bw) = 
\left(
\begin{array}{cc}
20w_1^3 & 0\\
0 & 2
\end{array}
\right)
\end{eqnarray}
The Hessian matrix $\overline{H}$ of the modified function $\overline{f}$
is singular at the optimum $\bw^\star=(0,-1)^T$. 
If the unconstrained method is designed for smooth derivatives, the algorithm will 
require many more iterations.

Thus, transformation of problems should be considered with \emph{caution}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Notes and references}



The issues generated by transformations in optimization problems presented 
in section \ref{introoptim-section-modelling} is detailed in \cite{Gill81MurrayWright},
chapter "Modelling".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%\begin{footnotesize}
%\subsection{Exercises}

%TODO : find something, or remove this section

%\end{footnotesize}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\newpage
\section{Answers to exercises}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Answers for section \ref{introoptim-section-exeroptimality}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-taylorquad}}{Taylor expansion of a quadratic function}
We have 
\begin{eqnarray}
&&f(\bx+\alpha\bp) \\
&=& \bb^T (\bx+\alpha\bp) + \frac{1}{2} (\bx+\alpha\bp)^T H (\bx+\alpha\bp) \\
&=& \bb^T \bx + \alpha \bb^T \bp + \frac{1}{2} \bx^T H (\bx+\alpha\bp) + \frac{1}{2} \alpha \bp^T H (\bx+\alpha\bp)\\
&=& \bb^T \bx + \alpha \bb^T \bp + \frac{1}{2} \bx^T H \bx + \frac{1}{2} \alpha \bx^T H \bp + \frac{1}{2} \alpha \bp^T H \bx + \frac{1}{2} \alpha^2 \bp^T H \bp\\
&=& f(\bx) + \alpha \bb^T \bp + \frac{1}{2} \alpha \bx^T H \bp + \frac{1}{2} \alpha \bp^T H \bx + \frac{1}{2} \alpha^2 \bp^T H \bp
\label{introoptim-exer-taylorquad3}
\end{eqnarray}
The symetry of the dot product implies 
\begin{eqnarray}
\bx^T H \bp 
&=& \bx^T (H \bp)  \\
&=& (H\bp)^T \bx \\
&=& \bp^T H^T \bx
\end{eqnarray}
By assumption, the matrix $H$ is symmetric, which implies $H^T = H$. 
Therefore, 
\begin{eqnarray}
\bx^T H \bp 
&=& \bp^T H \bx.
\end{eqnarray}
We plug the previous equality into the equation \ref{introoptim-exer-taylorquad3}
and get 
\begin{eqnarray}
f(\bx+\alpha\bp) 
&=& f(\bx) + \alpha \bb^T \bp + \alpha \bx^T H \bp + \frac{1}{2} \alpha^2 \bp^T H \bp.
\end{eqnarray}
The previous equation leads directly to the equation \ref{introoptim-exer-taylorquad2}.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{answer}{\ref{optimcond-exer-rosendirec}}{Rosenbrock's function in the eigenvectors directions}
\index{Rosenbrock H.H.}
Let us consider Rosenbrock's function defined by \ref{introoptim-rosenbrock}.
We have already seen in section \ref{introoptim-optimality-rosenbrock} how to define 
Rosenbrock's function in Scilab.
Let us create a plot representing the function $\phi_i(\alpha) = f(\bx^\star + \alpha \bu_i)$
for $i=1,2$. 
The following function \scifun{phi1} returns the value of the function $\phi_1$ and takes 
$\alpha$ and $\bx^\star$ as input arguments.
\lstset{language=scilabscript}
\begin{lstlisting}
function fs = phi1 ( a , xopt )
  [ fopt , gopt , Hopt ] = rosenbrock ( xopt )
  [R,D] = spec(Hopt)
  for i = 1 : size(a,"c")
    xs = xopt + a(i) * R(:,1)
    fs(i) = rosenbrock ( xs )
  end
endfunction
\end{lstlisting}
Because of Taylor's theorem, we can approximate Rosenbrock's function by a quadratic 
model in the neighborhood of the optimum $\bx^\star$. This is why we define in the following 
script the function \scifun{phi1\_approx} which uses the equation \ref{introoptim-quadratictaylor3}.
\lstset{language=scilabscript}
\begin{lstlisting}
function fs = phi1_approx ( a , xopt )
  [ fopt , gopt , Hopt ] = rosenbrock ( xopt )
  [R,D] = spec(Hopt)
  for i = 1 : size(a,"c")
    fs(i) = fopt + 0.5 * D(1,1) * a(i)^2
  end
endfunction
\end{lstlisting}
The following script allows to compare the actual function value to the quadratic 
model and produces the plot presented in figure \ref{fig-rosendirection1}. 
\lstset{language=scilabscript}
\begin{lstlisting}
xopt = [1.0 1.0]';
a = linspace ( 0 , 1.e-1 , 100 );
scf();
y1 = phi1 ( a , xopt );
plot ( x , y1 , "b-" )
y1_app = phi1_approx ( a , xopt );
plot ( x , y1_app , "r-." )
legend ( [ "Actual" "Quadratic" ] )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm,angle=0]{optimcond/rosenbrock-direction1.pdf}
\caption{Comparison of the function $\phi_(\alpha) = f ( \bx^\star + \alpha \bu_1 )$ with the quadratic model $\phi_1^q = f(\bx^\star) + \frac{1}{2}\lambda_1 \alpha^2$.}
\label{fig-rosendirection1}
\end{center}
\end{figure}

This confirms that the quadratic model is accurate only when $\alpha$ is near zero. 
It is easy to duplicate the previous functions and make necessary adaptations to 
make the plot associated with the second eigenvector, as in the following script.
This produces the figure \ref{fig-rosendirection2}.
\lstset{language=scilabscript}
\begin{lstlisting}
function fs = phi2 ( a , xopt )
  [ fopt , gopt , Hopt ] = rosenbrock ( xopt )
  [R,D] = spec(Hopt)
  for i = 1 : size(a,"c")
    xs = xopt + a(i) * R(:,2)
    fs(i) = rosenbrock ( xs )
  end
endfunction
function fs = phi2_approx ( a , xopt )
  [ fopt , gopt , Hopt ] = rosenbrock ( xopt )
  [R,D] = spec(Hopt)
  for i = 1 : size(a,"c")
    fs(i) = fopt + 0.5 * D(2,2) * a(i)^2
  end
endfunction
scf();
y2 = phi2(a,xopt,R);
plot ( x , y2 )
y2_app = phi2_approx ( a , xopt );
plot ( x , y2_app , "r-." )
legend ( [ "Actual" "Quadratic" ] )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=8cm,angle=0]{optimcond/rosenbrock-direction2.pdf}
\caption{Comparison of the function $\phi_(\alpha) = f ( \bx^\star + \alpha \bu_2 )$ with the quadratic model $\phi_2^q = f(\bx^\star) + \frac{1}{2}\lambda_2 \alpha^2$.}
\label{fig-rosendirection2}
\end{center}
\end{figure}

We notice that the range of $y$ values in much larger for the second eigenvector 
direction than for the first eigenvector direction. Indeed, we have already seen that 
the eigenvalues are $\lambda_1 = 0.3993631$ and $\lambda_2 = 1001.6006$. Therefore,
the variation produced by the second eigenvalue is much larger than the variation 
produced by the first eigenvalue. If we use only one plot instead of two separate graphics,
we have the feeling that the function is "flat" in the direction of the first eigenvector.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{answer}{\ref{introoptim-exer-floatmv1}}{Limitation of floating point accuracy - Multivariate case}
Let us proove the proposition \ref{introoptim-prop-floatmv1}.

We can use the same process as in the univariate case.
Let us assume that the floating point function value 
at the point $\bx^\star$ satisfies 
\begin{eqnarray}
\label{introoptim-eq-floatmv1}
fl(f(\bx^\star)) = f(\bx^\star) ( 1+\delta ),
\end{eqnarray}
where $|\delta| \leq \epsilon_M$ and $\epsilon_M>0$ is the machine 
relative precision. 
Let $\bp\in\RR^n> 0$ be the largest vector such that 
\begin{eqnarray}
\label{introoptim-exer-floatmv3}
|f(\bx^\star + \bp) - f(\bx^\star)| \leq \epsilon_M |f(\bx^\star)|.
\end{eqnarray}
Then, the point $\overline{\bx}=\bx^\star+\bp$ is associated with the best achievable 
floating point representation of the function value, since the relative difference 
between $f(\overline{\bx})$ and $f(\bx^\star)$ is lower than the machine precision.
Hence we have 
\begin{eqnarray}
\label{introoptim-eq-floatlimit1c}
|f(\overline{x}) - f(x^\star)| \leq \epsilon_M |f(x^\star)|
\end{eqnarray}
which implies the equality \ref{introoptim-prop-floatmv1d}.

Let us assume that the function has the expression 
\begin{eqnarray}
f(\bx)
&=& \bb^T \bx + \frac{1}{2}\bx^T H \bx,
\end{eqnarray}
where $\bb\in\RR^n$ and $H$ is a $n\times n$ real symmetric, positive definite 
matrix. 
The gradient is $\bg(\bx)=\bb + H\bx$ and the Hessian matrix is $H$. 
Hence the following Taylor expansion of the function $f$ is exact :
\begin{eqnarray}
f(\bx^\star+\bp) 
&=& f(\bx^\star) 
+ \bp^T \bg(\bx^\star) + \frac{1}{2}\bp^T H \bp.
\end{eqnarray}
By hypothesis, the point $\bx^\star$ is a strong local optimum. Hence, by the 
proposition \ref{introoptim-necessarymulti}, the gradient at optimum 
is such that $\bg(\bx^\star)=0$. This leads to the equation 
\begin{eqnarray}
\label{introoptim-eq-floatmv4}
f(\bx^\star+\bp) 
&=& f(\bx^\star)+ \frac{1}{2}\bp^T H \bp.
\end{eqnarray}
Hence, we have 
\begin{eqnarray}
\label{introoptim-eq-floatmv5}
| f(\bx^\star+\bp) - f(\bx^\star)| 
= \frac{1}{2} | \bp^T H \bp |.
\end{eqnarray}
Let us assume that the vector $\bp$ is an eigenvector 
of the Hessian matrix $H$, associated with the 
eigenvalue $\lambda$. 
Therefore, the term $\bp^T H \bp$ in the previous equation simplifies 
to $\lambda \|\bp\|^2$.
The proposition \ref{introoptim-necessarymulti} implies that the 
eigenvalue $\lambda$ is strictly positive. 
Hence, the equation \ref{introoptim-eq-floatmv5} leads to 
\begin{eqnarray}
\label{introoptim-eq-floatmv6}
| f(\bx^\star+\bp) - f(\bx^\star)| 
= \frac{1}{2} \lambda \| \bp \|^2.
\end{eqnarray}

We now plug the inequality \ref{introoptim-exer-floatmv3} into the previous 
equation and get
\begin{eqnarray}
\label{introoptim-eq-floatmv7}
\frac{1}{2} \lambda \| \bp \|^2
\leq \epsilon_M |f(\bx^\star)|.
\end{eqnarray}
The previous equation immediately leads to the inequality 
\ref{introoptim-prop-floatmv2}, which concludes the first part of this 
proof.

Since the function $f$ is quadratic, we can write the following exact Taylor expansion:
\begin{eqnarray}
\label{introoptim-eq-floatmv8}
\bg(\bx^\star+\bp) 
&=& \bg(\bx^\star) + H \bp.
\end{eqnarray}
By the proposition \ref{introoptim-necessarymulti}, the gradient at 
optimum is zero, which implies that $\bg(\bx^\star)=0$. This 
simplifies the previous equation into
\begin{eqnarray}
\label{introoptim-eq-floatmv9}
\bg(\bx^\star+\bp) &=& H\bp.
\end{eqnarray}
Moreover, we have $H\bp = \lambda\bp$. Hence, 
\begin{eqnarray}
\label{introoptim-eq-floatmv10}
\bg(\bx^\star+\bp) &\approx& \lambda\bp.
\end{eqnarray}
We finally plug the inequality \ref{introoptim-prop-floatmv2} into the 
previous approximation, which leads to the inequality \ref{introoptim-prop-floatmv3}
and concludes the proof.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{answer}{\ref{optimcond-exer-sensitivityan}}{Sensitivity analysis of the optimum}
Let us prove the proposition \ref{optimcond-prop-sensitivitiyanalysis}.
The proof is based on the equality \ref{introoptim-quadratictaylor3}.
Let us define $s,t>0$ and let us consider the points $\bx_s = \bx^\star + s \bu_1$ and 
$\bx_t = \bx^\star + t\bu_n$. Let us define $\phi_1 ( \alpha ) = f ( \bx^\star + \alpha \bu_1 )$
and $\phi_n ( \alpha ) = f ( \bx^\star + \alpha \bu_n )$ for all $\alpha>0$.
By the equality \ref{introoptim-quadratictaylor3}, we have 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan4}
\phi_1(s)=f(\bx^\star) + \frac{1}{2} \lambda_1 s^2, \qquad
\phi_n(t)=f(\bx^\star) + \frac{1}{2} \lambda_n t^2.
\end{eqnarray}
Let us set $t$ to any positive value and let us search for $s$ 
such that
\begin{eqnarray}
\label{optimcond-exer-sensitivityan5}
\phi_1(s)=\phi_n(t).
\end{eqnarray}
This situation is presented in figure \ref{fig-sensitivityan}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm,angle=0]{optimcond/sensitivityanalysis-quadratic.pdf}
\caption{Computing $s>0$ such that $f ( \bx^\star + s \bu_1 ) = f ( \bx^\star + t \bu_n )$. - Notice that the derivatives satisfy $0<\phi'(s)<\phi'(t)$.}
\label{fig-sensitivityan}
\end{center}
\end{figure}

We plug the equalities \ref{optimcond-exer-sensitivityan4} into \ref{optimcond-exer-sensitivityan5} 
and get
\begin{eqnarray}
\label{optimcond-exer-sensitivityan6}
 \lambda_1 s^2 =  \lambda_n t^2,
\end{eqnarray}
which leads to 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan7}
s = t \sqrt{\frac{\lambda_n}{\lambda_1}}.
\end{eqnarray}
By hypothesis, we have $\lambda_n > \lambda_1$, which implies 
that $s > t$. 
Moreover, we have $\|\bx_s - \bx^\star\|  = \|s\bu_1\| = s$
and $\|\bx_t - \bx^\star\|  = \|t\bu_n\| = t$ since the vectors $\bu_1$
and $\bu_n$ are normalized. 
This leads to the equation \ref{optimcond-exer-sensitivityan2}.

We can now compute the gradient of the function $f$ at the points $\bx_s$
and $\bx_t$. A Taylor expansion of the gradient leads to 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan9}
\bg(\bx_s) = \bg(\bx^\star + s \bu_1) = \bg(\bx^\star) + H(\bx^\star) (s\bu_1), \\
\bg(\bx_t) = \bg(\bx^\star + t \bu_1) = \bg(\bx^\star) + H(\bx^\star) (t\bu_n).
\end{eqnarray}
By the proposition \ref{introoptim-necessarymulti}, the optimality of the 
point $\bx^\star$ implies $\bg(\bx^\star) = 0$. Therefore, 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan10}
\bg(\bx_s) = s \lambda_1 \bu_1, \\
\bg(\bx_t) = t \lambda_n \bu_n,
\end{eqnarray}
which implies 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan11}
&&\|\bg(\bx_s)\| = s \lambda_1 , \\
&&\|\bg(\bx_t)\| = t \lambda_n .
\end{eqnarray}
We consider the ratio of the norms (which are both nonzero, since $s>t>0$) and get
\begin{eqnarray}
\label{optimcond-exer-sensitivityan12}
\frac{\|\bg(\bx_t)\|}{\|\bg(\bx_s)\|} = \frac{t}{s} \frac{\lambda_n}{\lambda_1}.
\end{eqnarray}
We plug the equation \ref{optimcond-exer-sensitivityan7} into the previous 
equality and get 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan13}
\frac{\|\bg(\bx_t)\|}{\|\bg(\bx_s)\|} = \sqrt{\frac{\lambda_1}{\lambda_n}} \frac{\lambda_n}{\lambda_1},
\end{eqnarray}
which simplifies to 
\begin{eqnarray}
\label{optimcond-exer-sensitivityan14}
\frac{\|\bg(\bx_t)\|}{\|\bg(\bx_s)\|} = \sqrt{\frac{\lambda_n}{\lambda_1}}.
\end{eqnarray}
This immediately leads to the equation \ref{optimcond-exer-sensitivityan3}.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{answer}{\ref{optimcond-exer-sensanrosenbrock}}{Sensitivity analysis for Rosenbrock's function}
We have already seen in section \ref{introoptim-optimality-rosenbrock} how to define 
Rosenbrock's function in Scilab and how to produce the contour plot in the neighborhood of the 
optimum $\bx^\star = (1,1)^T$. This optimum is stored in the variable \scivar{xopt}. 
We also used the \scifun{spec} function and computed the eigenvectors \scivar{R}.
In the following script, we set the parameter $t$ to $2\cdot 10^{-3}$ and compute the 
associated point $\bx_t = \bx^\star + t\bu_2$. Then we compute the function value \scivar{ft} and 
the gradient \scivar{gt} at the point \scivar{xt}.
\lstset{language=scilabscript}
\begin{lstlisting}
t = 2.e-3;
xt = xopt + t * R(:,2);
[ft,gt] = rosenbrock ( xt );
\end{lstlisting}
In order to compute the point $\bx_s$ such that $f(\bx_s) = f(\bx_t)$, we cannot 
rely on the equation \ref{optimcond-exer-sensitivityan7}, since Rosenbrock's function 
is not quadratic. Instead, we must use a nonlinear solver in order to solve the 
nonlinear equation $\phi(s) - \phi(t) = 0$ for $s$. In the following script, we define 
the function \scifun{phizero} which is defined by $\phi_0(s) = f(\bx^\star + s\bu_1) - f(\bx^\star + t\bu_2)$. 
\lstset{language=scilabscript}
\begin{lstlisting}
function fs = phizero ( s , ft , R )
  xs = xopt + s * R(:,1)
  fs = rosenbrock ( xs ) - ft
endfunction
\end{lstlisting}
The \scifun{fzero} function computes the zero of a given function, that is, solves nonlinear 
equations. In the following session, we use this function in order to compute $s$ such that 
$\phi_0(s) = 0$, given $t$. Since the \scifun{phizero} function requires more than one argument, 
we pass the three arguments \scivar{phizero}, \scivar{ft} and \scivar{R} as a list.
\lstset{language=scilabscript}
\begin{lstlisting}
-->s = fsolve ( 1 , list ( phizero , ft , R ) )
 s  =
    0.0914089  
\end{lstlisting}
We can compare the previous result with the result predicted by the equation 
\ref{optimcond-exer-sensitivityan7} for a quadratic function.
\lstset{language=scilabscript}
\begin{lstlisting}
-->t * sqrt(cond(Hopt))
 ans  =
    0.1001601  
\end{lstlisting}
The orders of magnitude are the same, but the values are significantly different.
Now that the value of $s$ is determined, we can compute the point $\bx_s$ and its 
associated function value and gradient.
\lstset{language=scilabscript}
\begin{lstlisting}
xs = xopt + s * R(:,1);
[fs,gs] = rosenbrock ( xs );
\end{lstlisting}
In the following script, we plot the two points $\bx_s$ and $\bx_t$, which 
produces the plot presented in figure \ref{fig-exer-sensanrosenbrock}.
\lstset{language=scilabscript}
\begin{lstlisting}
plot(xs(1),xs(2),"b*")
plot(xt(1),xt(2),"ro")
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=15cm,angle=0]{optimcond/rosenbrock-sensitivity.pdf}
\caption{Two points $\bx_s$ and $\bx_t$ with the same function value.}
\label{fig-exer-sensanrosenbrock}
\end{center}
\end{figure}

In the following script, we compare the norms of the vectors $\bx_s-\bx^\star$ and 
$\bx_t-\bx^\star$. Additionally, we compare the norms of the gradient at the points 
$\bx_s$ and $\bx_t$. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->[norm(xs - xopt) norm(xt - xopt)]
 ans  =
    0.0914089    0.002  
-->[norm(gs) norm(gt)]
 ans  =
    0.7200074    1.9989072  
\end{lstlisting}
We see that $\bx_t$ is much closer to the optimum (i.e. $\bx_t$ is "better") 
but the gradient at $\bx_s$ is closer to zero (i.e. $\bx_s$ is "better"). 
This is an effect of the conditioning of the problem. 
In the following script, we compute the value of the square root of the condition 
number of the Hessian matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
-->cond(Hopt)
 ans  =
    2508.0096  
-->sqrt(cond(Hopt))
 ans  =
    50.080032  
\end{lstlisting}
This factor is not extremely large, which explains why the two points $\bx_s$ and $\bx_t$ do
not differ too greatly in magnitude.
\end{answer}

\end{footnotesize}

